*** a/src/backend/utils/sort/tuplesort.c
--- b/src/backend/utils/sort/tuplesort.c
***************
*** 1411,1433 **** tuplesort_performsort(Tuplesortstate *state)
   * Internal routine to fetch the next tuple in either forward or back
   * direction into *stup.  Returns FALSE if no more tuples.
   * If *should_free is set, the caller must pfree stup.tuple when done with it.
   */
  static bool
  tuplesort_gettuple_common(Tuplesortstate *state, bool forward,
  						  SortTuple *stup, bool *should_free)
  {
  	unsigned int tuplen;
  
  	switch (state->status)
  	{
  		case TSS_SORTEDINMEM:
  			Assert(forward || state->randomAccess);
! 			*should_free = false;
  			if (forward)
  			{
  				if (state->current < state->memtupcount)
  				{
! 					*stup = state->memtuples[state->current++];
  					return true;
  				}
  				state->eof_reached = true;
--- 1411,1439 ----
   * Internal routine to fetch the next tuple in either forward or back
   * direction into *stup.  Returns FALSE if no more tuples.
   * If *should_free is set, the caller must pfree stup.tuple when done with it.
+  * stup may be null to move without fetching.
   */
  static bool
  tuplesort_gettuple_common(Tuplesortstate *state, bool forward,
  						  SortTuple *stup, bool *should_free)
  {
  	unsigned int tuplen;
+ 	SortTuple dummy;
+ 	SortTuple *ptup = stup ? stup : &dummy;
  
  	switch (state->status)
  	{
  		case TSS_SORTEDINMEM:
  			Assert(forward || state->randomAccess);
! 			if (should_free)
! 				*should_free = false;
  			if (forward)
  			{
  				if (state->current < state->memtupcount)
  				{
! 					if (stup)
! 						*stup = state->memtuples[state->current];
! 					state->current++;
  					return true;
  				}
  				state->eof_reached = true;
***************
*** 1459,1479 **** tuplesort_gettuple_common(Tuplesortstate *state, bool forward,
  					if (state->current <= 0)
  						return false;
  				}
! 				*stup = state->memtuples[state->current - 1];
  				return true;
  			}
  			break;
  
  		case TSS_SORTEDONTAPE:
  			Assert(forward || state->randomAccess);
! 			*should_free = true;
  			if (forward)
  			{
  				if (state->eof_reached)
  					return false;
  				if ((tuplen = getlen(state, state->result_tape, true)) != 0)
  				{
! 					READTUP(state, stup, state->result_tape, tuplen);
  					return true;
  				}
  				else
--- 1465,1489 ----
  					if (state->current <= 0)
  						return false;
  				}
! 				if (stup)
! 					*stup = state->memtuples[state->current - 1];
  				return true;
  			}
  			break;
  
  		case TSS_SORTEDONTAPE:
  			Assert(forward || state->randomAccess);
! 			if (should_free)
! 				*should_free = true;
  			if (forward)
  			{
  				if (state->eof_reached)
  					return false;
  				if ((tuplen = getlen(state, state->result_tape, true)) != 0)
  				{
! 					READTUP(state, ptup, state->result_tape, tuplen);
! 					if (!stup && dummy.tuple)
! 						pfree(dummy.tuple);
  					return true;
  				}
  				else
***************
*** 1546,1557 **** tuplesort_gettuple_common(Tuplesortstate *state, bool forward,
  									  state->result_tape,
  									  tuplen))
  				elog(ERROR, "bogus tuple length in backward scan");
! 			READTUP(state, stup, state->result_tape, tuplen);
  			return true;
  
  		case TSS_FINALMERGE:
  			Assert(forward);
! 			*should_free = true;
  
  			/*
  			 * This code should match the inner loop of mergeonerun().
--- 1556,1570 ----
  									  state->result_tape,
  									  tuplen))
  				elog(ERROR, "bogus tuple length in backward scan");
! 			READTUP(state, ptup, state->result_tape, tuplen);
! 			if (!stup && dummy.tuple)
! 				pfree(dummy.tuple);
  			return true;
  
  		case TSS_FINALMERGE:
  			Assert(forward);
! 			if (should_free)
! 				*should_free = true;
  
  			/*
  			 * This code should match the inner loop of mergeonerun().
***************
*** 1563,1573 **** tuplesort_gettuple_common(Tuplesortstate *state, bool forward,
  				int			tupIndex;
  				SortTuple  *newtup;
  
! 				*stup = state->memtuples[0];
  				/* returned tuple is no longer counted in our memory space */
! 				if (stup->tuple)
  				{
! 					tuplen = GetMemoryChunkSpace(stup->tuple);
  					state->availMem += tuplen;
  					state->mergeavailmem[srcTape] += tuplen;
  				}
--- 1576,1586 ----
  				int			tupIndex;
  				SortTuple  *newtup;
  
! 				*ptup = state->memtuples[0];
  				/* returned tuple is no longer counted in our memory space */
! 				if (ptup->tuple)
  				{
! 					tuplen = GetMemoryChunkSpace(ptup->tuple);
  					state->availMem += tuplen;
  					state->mergeavailmem[srcTape] += tuplen;
  				}
***************
*** 1598,1603 **** tuplesort_gettuple_common(Tuplesortstate *state, bool forward,
--- 1611,1618 ----
  				newtup->tupindex = state->mergefreelist;
  				state->mergefreelist = tupIndex;
  				state->mergeavailslots[srcTape]++;
+ 				if (!stup && dummy.tuple)
+ 					pfree(dummy.tuple);
  				return true;
  			}
  			return false;
***************
*** 1620,1639 **** tuplesort_gettupleslot(Tuplesortstate *state, bool forward,
  	MemoryContext oldcontext = MemoryContextSwitchTo(state->sortcontext);
  	SortTuple	stup;
  	bool		should_free;
  
! 	if (!tuplesort_gettuple_common(state, forward, &stup, &should_free))
! 		stup.tuple = NULL;
  
  	MemoryContextSwitchTo(oldcontext);
  
! 	if (stup.tuple)
  	{
! 		ExecStoreMinimalTuple((MinimalTuple) stup.tuple, slot, should_free);
  		return true;
  	}
  	else
  	{
! 		ExecClearTuple(slot);
  		return false;
  	}
  }
--- 1635,1656 ----
  	MemoryContext oldcontext = MemoryContextSwitchTo(state->sortcontext);
  	SortTuple	stup;
  	bool		should_free;
+ 	bool        found;
  
! 	found = tuplesort_gettuple_common(state, forward, (slot ? &stup : NULL), &should_free);
  
  	MemoryContextSwitchTo(oldcontext);
  
! 	if (found)
  	{
! 		if (slot)
! 			ExecStoreMinimalTuple((MinimalTuple) stup.tuple, slot, should_free);
  		return true;
  	}
  	else
  	{
! 		if (slot)
! 			ExecClearTuple(slot);
  		return false;
  	}
  }
***************
*** 1692,1715 **** tuplesort_getdatum(Tuplesortstate *state, bool forward,
  	SortTuple	stup;
  	bool		should_free;
  
! 	if (!tuplesort_gettuple_common(state, forward, &stup, &should_free))
  	{
  		MemoryContextSwitchTo(oldcontext);
  		return false;
  	}
  
! 	if (stup.isnull1 || state->datumTypeByVal)
  	{
! 		*val = stup.datum1;
! 		*isNull = stup.isnull1;
! 	}
! 	else
! 	{
! 		if (should_free)
  			*val = stup.datum1;
  		else
! 			*val = datumCopy(stup.datum1, false, state->datumTypeLen);
! 		*isNull = false;
  	}
  
  	MemoryContextSwitchTo(oldcontext);
--- 1709,1735 ----
  	SortTuple	stup;
  	bool		should_free;
  
! 	if (!tuplesort_gettuple_common(state, forward, (val ? &stup : NULL), &should_free))
  	{
  		MemoryContextSwitchTo(oldcontext);
  		return false;
  	}
  
! 	if (val)
  	{
! 		if (stup.isnull1 || state->datumTypeByVal)
! 		{
  			*val = stup.datum1;
+ 			*isNull = stup.isnull1;
+ 		}
  		else
! 		{
! 			if (should_free)
! 				*val = stup.datum1;
! 			else
! 				*val = datumCopy(stup.datum1, false, state->datumTypeLen);
! 			*isNull = false;
! 		}
  	}
  
  	MemoryContextSwitchTo(oldcontext);
*** a/src/bin/pg_dump/pg_dump.c
--- b/src/bin/pg_dump/pg_dump.c
***************
*** 229,234 **** static void getTableData(TableInfo *tblinfo, int numTables, bool oids);
--- 229,235 ----
  static void makeTableDataInfo(TableInfo *tbinfo, bool oids);
  static void buildMatViewRefreshDependencies(Archive *fout);
  static void getTableDataFKConstraints(void);
+ static char *format_aggregate_arguments(FuncInfo *finfo, char *funcargs);
  static char *format_function_arguments(FuncInfo *finfo, char *funcargs,
  									   bool is_agg);
  static char *format_function_arguments_old(Archive *fout,
***************
*** 9363,9368 **** dumpProcLang(Archive *fout, ProcLangInfo *plang)
--- 9364,9385 ----
  }
  
  /*
+  * format_aggregate_arguments: generate function name and argument list
+  *
+  * This is used when we can rely on pg_get_aggregate_arguments to format
+  * the argument list.
+  */
+ static char *
+ format_aggregate_arguments(FuncInfo *finfo, char *funcargs)
+ {
+ 	PQExpBufferData fn;
+ 
+ 	initPQExpBuffer(&fn);
+ 	appendPQExpBuffer(&fn, "%s%s", fmtId(finfo->dobj.name), funcargs);
+ 	return fn.data;
+ }
+ 
+ /*
   * format_function_arguments: generate function name and argument list
   *
   * This is used when we can rely on pg_get_function_arguments to format
***************
*** 11418,11432 **** dumpAgg(Archive *fout, AggInfo *agginfo)
--- 11435,11456 ----
  	int			i_aggtransfn;
  	int			i_aggfinalfn;
  	int			i_aggsortop;
+ 	int			i_aggtranssortop;
+ 	int			i_hypothetical;
+ 	int			i_isstrict;
  	int			i_aggtranstype;
  	int			i_agginitval;
  	int			i_convertok;
  	const char *aggtransfn;
  	const char *aggfinalfn;
  	const char *aggsortop;
+ 	const char *aggtranssortop;
  	const char *aggtranstype;
  	const char *agginitval;
+ 	bool        hypothetical;
+ 	bool        isstrict;
  	bool		convertok;
+ 	bool        has_comma = false;
  
  	/* Skip if not to be dumped */
  	if (!agginfo->aggfn.dobj.dump || dataOnly)
***************
*** 11442,11452 **** dumpAgg(Archive *fout, AggInfo *agginfo)
  	selectSourceSchema(fout, agginfo->aggfn.dobj.namespace->dobj.name);
  
  	/* Get aggregate-specific details */
! 	if (fout->remoteVersion >= 80400)
  	{
  		appendPQExpBuffer(query, "SELECT aggtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "aggsortop::pg_catalog.regoperator, "
  						  "agginitval, "
  						  "'t'::boolean AS convertok, "
  						  "pg_catalog.pg_get_function_arguments(p.oid) AS funcargs, "
--- 11466,11496 ----
  	selectSourceSchema(fout, agginfo->aggfn.dobj.namespace->dobj.name);
  
  	/* Get aggregate-specific details */
! 	if (fout->remoteVersion >= 90400)
! 	{
! 		appendPQExpBuffer(query, "SELECT aggtransfn, "
! 						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
! 						  "aggsortop::pg_catalog.regoperator, "
! 						  "aggtranssortop::pg_catalog.regoperator, "
! 						  "(aggordnargs = -2) as hypothetical, "
! 						  "p.proisstrict as isstrict, "
! 						  "agginitval, "
! 						  "'t'::boolean AS convertok, "
! 						  "pg_catalog.pg_get_aggregate_arguments(p.oid) AS funcargs, "
! 						  "pg_catalog.pg_get_aggregate_identity_arguments(p.oid) AS funciargs "
! 					  "FROM pg_catalog.pg_aggregate a, pg_catalog.pg_proc p "
! 						  "WHERE a.aggfnoid = p.oid "
! 						  "AND p.oid = '%u'::pg_catalog.oid",
! 						  agginfo->aggfn.dobj.catId.oid);
! 	}
! 	else if (fout->remoteVersion >= 80400)
  	{
  		appendPQExpBuffer(query, "SELECT aggtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "aggsortop::pg_catalog.regoperator, "
+ 						  "0 as aggtranssortop, "
+ 						  "false as hypothetical, "
+ 						  "false as isstrict, "
  						  "agginitval, "
  						  "'t'::boolean AS convertok, "
  						  "pg_catalog.pg_get_function_arguments(p.oid) AS funcargs, "
***************
*** 11461,11466 **** dumpAgg(Archive *fout, AggInfo *agginfo)
--- 11505,11513 ----
  		appendPQExpBuffer(query, "SELECT aggtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "aggsortop::pg_catalog.regoperator, "
+ 						  "0 as aggtranssortop, "
+ 						  "false as hypothetical, "
+ 						  "false as isstrict, "
  						  "agginitval, "
  						  "'t'::boolean AS convertok "
  						  "FROM pg_catalog.pg_aggregate a, pg_catalog.pg_proc p "
***************
*** 11473,11478 **** dumpAgg(Archive *fout, AggInfo *agginfo)
--- 11520,11528 ----
  		appendPQExpBuffer(query, "SELECT aggtransfn, "
  						  "aggfinalfn, aggtranstype::pg_catalog.regtype, "
  						  "0 AS aggsortop, "
+ 						  "0 as aggtranssortop, "
+ 						  "'f'::boolean as hypothetical, "
+ 						  "'f'::boolean as isstrict, "
  						  "agginitval, "
  						  "'t'::boolean AS convertok "
  					  "FROM pg_catalog.pg_aggregate a, pg_catalog.pg_proc p "
***************
*** 11485,11490 **** dumpAgg(Archive *fout, AggInfo *agginfo)
--- 11535,11543 ----
  		appendPQExpBuffer(query, "SELECT aggtransfn, aggfinalfn, "
  						  "format_type(aggtranstype, NULL) AS aggtranstype, "
  						  "0 AS aggsortop, "
+ 						  "0 as aggtranssortop, "
+ 						  "'f'::boolean as hypothetical, "
+ 						  "'f'::boolean as isstrict, "
  						  "agginitval, "
  						  "'t'::boolean AS convertok "
  						  "FROM pg_aggregate "
***************
*** 11497,11502 **** dumpAgg(Archive *fout, AggInfo *agginfo)
--- 11550,11558 ----
  						  "aggfinalfn, "
  						  "(SELECT typname FROM pg_type WHERE oid = aggtranstype1) AS aggtranstype, "
  						  "0 AS aggsortop, "
+ 						  "0 as aggtranssortop, "
+ 						  "'f'::boolean as hypothetical, "
+ 						  "'f'::boolean as isstrict, "
  						  "agginitval1 AS agginitval, "
  						  "(aggtransfn2 = 0 and aggtranstype2 = 0 and agginitval2 is null) AS convertok "
  						  "FROM pg_aggregate "
***************
*** 11509,11514 **** dumpAgg(Archive *fout, AggInfo *agginfo)
--- 11565,11573 ----
  	i_aggtransfn = PQfnumber(res, "aggtransfn");
  	i_aggfinalfn = PQfnumber(res, "aggfinalfn");
  	i_aggsortop = PQfnumber(res, "aggsortop");
+ 	i_aggtranssortop = PQfnumber(res, "aggtranssortop");
+ 	i_hypothetical = PQfnumber(res, "hypothetical");
+ 	i_isstrict = PQfnumber(res, "isstrict");
  	i_aggtranstype = PQfnumber(res, "aggtranstype");
  	i_agginitval = PQfnumber(res, "agginitval");
  	i_convertok = PQfnumber(res, "convertok");
***************
*** 11516,11526 **** dumpAgg(Archive *fout, AggInfo *agginfo)
  	aggtransfn = PQgetvalue(res, 0, i_aggtransfn);
  	aggfinalfn = PQgetvalue(res, 0, i_aggfinalfn);
  	aggsortop = PQgetvalue(res, 0, i_aggsortop);
  	aggtranstype = PQgetvalue(res, 0, i_aggtranstype);
  	agginitval = PQgetvalue(res, 0, i_agginitval);
  	convertok = (PQgetvalue(res, 0, i_convertok)[0] == 't');
  
! 	if (fout->remoteVersion >= 80400)
  	{
  		/* 8.4 or later; we rely on server-side code for most of the work */
  		char	   *funcargs;
--- 11575,11599 ----
  	aggtransfn = PQgetvalue(res, 0, i_aggtransfn);
  	aggfinalfn = PQgetvalue(res, 0, i_aggfinalfn);
  	aggsortop = PQgetvalue(res, 0, i_aggsortop);
+ 	aggtranssortop = PQgetvalue(res, 0, i_aggtranssortop);
+ 	hypothetical = (PQgetvalue(res, 0, i_hypothetical)[0] == 't');
+ 	isstrict = (PQgetvalue(res, 0, i_isstrict)[0] == 't');
  	aggtranstype = PQgetvalue(res, 0, i_aggtranstype);
  	agginitval = PQgetvalue(res, 0, i_agginitval);
  	convertok = (PQgetvalue(res, 0, i_convertok)[0] == 't');
  
! 	if (fout->remoteVersion >= 90400)
! 	{
! 		/* 9.4 or later; we rely on server-side code for almost all of the work */
! 		char	   *funcargs;
! 		char	   *funciargs;
! 
! 		funcargs = PQgetvalue(res, 0, PQfnumber(res, "funcargs"));
! 		funciargs = PQgetvalue(res, 0, PQfnumber(res, "funciargs"));
! 		aggfullsig = format_aggregate_arguments(&agginfo->aggfn, funcargs);
! 		aggsig = format_aggregate_arguments(&agginfo->aggfn, funciargs);
! 	}
! 	else if (fout->remoteVersion >= 80400)
  	{
  		/* 8.4 or later; we rely on server-side code for most of the work */
  		char	   *funcargs;
***************
*** 11550,11585 **** dumpAgg(Archive *fout, AggInfo *agginfo)
  	if (fout->remoteVersion >= 70300)
  	{
  		/* If using 7.3's regproc or regtype, data is already quoted */
! 		appendPQExpBuffer(details, "    SFUNC = %s,\n    STYPE = %s",
! 						  aggtransfn,
! 						  aggtranstype);
  	}
  	else if (fout->remoteVersion >= 70100)
  	{
  		/* format_type quotes, regproc does not */
! 		appendPQExpBuffer(details, "    SFUNC = %s,\n    STYPE = %s",
  						  fmtId(aggtransfn),
  						  aggtranstype);
  	}
  	else
  	{
  		/* need quotes all around */
! 		appendPQExpBuffer(details, "    SFUNC = %s,\n",
  						  fmtId(aggtransfn));
  		appendPQExpBuffer(details, "    STYPE = %s",
  						  fmtId(aggtranstype));
  	}
  
! 	if (!PQgetisnull(res, 0, i_agginitval))
  	{
! 		appendPQExpBuffer(details, ",\n    INITCOND = ");
! 		appendStringLiteralAH(details, agginitval, fout);
  	}
  
! 	if (strcmp(aggfinalfn, "-") != 0)
  	{
! 		appendPQExpBuffer(details, ",\n    FINALFUNC = %s",
! 						  aggfinalfn);
  	}
  
  	aggsortop = convertOperatorReference(fout, aggsortop);
--- 11623,11680 ----
  	if (fout->remoteVersion >= 70300)
  	{
  		/* If using 7.3's regproc or regtype, data is already quoted */
! 		/*
! 		 * either or both of SFUNC and STYPE might be missing in >90400,
! 		 * but if SFUNC is missing, then FINALFUNC will always be present,
! 		 * and if SFUNC is present then STYPE must also be present; the
! 		 * code below relies on these conditions to keep the commas in the
! 		 * right places. STRICT must be forced to false if SFUNC is present.
! 		 */
! 
! 		if (strcmp(aggtransfn,"-") != 0)
! 		{
! 			appendPQExpBuffer(details, "\n    SFUNC = %s,", aggtransfn);
! 			isstrict = false;
! 		}
! 
! 		if (strcmp(aggtranstype,"-") != 0)
! 			appendPQExpBuffer(details, "\n    STYPE = %s", aggtranstype);
! 		else
! 			has_comma = true;
  	}
  	else if (fout->remoteVersion >= 70100)
  	{
  		/* format_type quotes, regproc does not */
! 		appendPQExpBuffer(details, "\n    SFUNC = %s,\n    STYPE = %s",
  						  fmtId(aggtransfn),
  						  aggtranstype);
  	}
  	else
  	{
  		/* need quotes all around */
! 		appendPQExpBuffer(details, "\n    SFUNC = %s,\n",
  						  fmtId(aggtransfn));
  		appendPQExpBuffer(details, "    STYPE = %s",
  						  fmtId(aggtranstype));
  	}
  
! 	if (strcmp(aggfinalfn, "-") != 0)
  	{
! 		appendPQExpBuffer(details, "%s\n    FINALFUNC = %s",
! 						  (has_comma ? "" : ","),
! 						  aggfinalfn);
  	}
  
! 	if (hypothetical)
! 		appendPQExpBuffer(details, ",\n    HYPOTHETICAL");
! 
! 	if (isstrict)
! 		appendPQExpBuffer(details, ",\n    STRICT");
! 
! 	if (!PQgetisnull(res, 0, i_agginitval))
  	{
! 		appendPQExpBuffer(details, ",\n    INITCOND = ");
! 		appendStringLiteralAH(details, agginitval, fout);
  	}
  
  	aggsortop = convertOperatorReference(fout, aggsortop);
***************
*** 11589,11594 **** dumpAgg(Archive *fout, AggInfo *agginfo)
--- 11684,11696 ----
  						  aggsortop);
  	}
  
+ 	aggtranssortop = convertOperatorReference(fout, aggtranssortop);
+ 	if (aggtranssortop)
+ 	{
+ 		appendPQExpBuffer(details, ",\n    TRANSSORTOP = %s",
+ 						  aggtranssortop);
+ 	}
+ 
  	/*
  	 * DROP must be fully qualified in case same name appears in pg_catalog
  	 */
***************
*** 11596,11602 **** dumpAgg(Archive *fout, AggInfo *agginfo)
  					  fmtId(agginfo->aggfn.dobj.namespace->dobj.name),
  					  aggsig);
  
! 	appendPQExpBuffer(q, "CREATE AGGREGATE %s (\n%s\n);\n",
  					  aggfullsig, details->data);
  
  	appendPQExpBuffer(labelq, "AGGREGATE %s", aggsig);
--- 11698,11704 ----
  					  fmtId(agginfo->aggfn.dobj.namespace->dobj.name),
  					  aggsig);
  
! 	appendPQExpBuffer(q, "CREATE AGGREGATE %s (%s\n);\n",
  					  aggfullsig, details->data);
  
  	appendPQExpBuffer(labelq, "AGGREGATE %s", aggsig);
***************
*** 11625,11631 **** dumpAgg(Archive *fout, AggInfo *agginfo)
  	/*
  	 * Since there is no GRANT ON AGGREGATE syntax, we have to make the ACL
  	 * command look like a function's GRANT; in particular this affects the
! 	 * syntax for zero-argument aggregates.
  	 */
  	free(aggsig);
  	free(aggsig_tag);
--- 11727,11733 ----
  	/*
  	 * Since there is no GRANT ON AGGREGATE syntax, we have to make the ACL
  	 * command look like a function's GRANT; in particular this affects the
! 	 * syntax for zero-argument aggregates and ordered set functions.
  	 */
  	free(aggsig);
  	free(aggsig_tag);
*** a/src/bin/psql/describe.c
--- b/src/bin/psql/describe.c
***************
*** 72,78 **** describeAggregates(const char *pattern, bool verbose, bool showSystem)
  					  gettext_noop("Name"),
  					  gettext_noop("Result data type"));
  
! 	if (pset.sversion >= 80400)
  		appendPQExpBuffer(&buf,
  						  "  CASE WHEN p.pronargs = 0\n"
  						  "    THEN CAST('*' AS pg_catalog.text)\n"
--- 72,82 ----
  					  gettext_noop("Name"),
  					  gettext_noop("Result data type"));
  
! 	if (pset.sversion >= 90400)
! 		appendPQExpBuffer(&buf,
! 					      " pg_catalog.pg_get_aggregate_arguments(p.oid) AS \"%s\",\n",
! 						  gettext_noop("Argument data types"));
! 	else if (pset.sversion >= 80400)
  		appendPQExpBuffer(&buf,
  						  "  CASE WHEN p.pronargs = 0\n"
  						  "    THEN CAST('*' AS pg_catalog.text)\n"
***************
*** 254,260 **** describeFunctions(const char *functypes, const char *pattern, bool verbose, bool
  					  gettext_noop("Schema"),
  					  gettext_noop("Name"));
  
! 	if (pset.sversion >= 80400)
  		appendPQExpBuffer(&buf,
  					"  pg_catalog.pg_get_function_result(p.oid) as \"%s\",\n"
  				 "  pg_catalog.pg_get_function_arguments(p.oid) as \"%s\",\n"
--- 258,283 ----
  					  gettext_noop("Schema"),
  					  gettext_noop("Name"));
  
! 	if (pset.sversion >= 90400)
! 		appendPQExpBuffer(&buf,
! 					"  pg_catalog.pg_get_function_result(p.oid) as \"%s\",\n"
! 				 "  CASE WHEN p.proisagg THEN pg_catalog.pg_get_aggregate_arguments(p.oid)\n"
!                  "       ELSE pg_catalog.pg_get_function_arguments(p.oid) END as \"%s\",\n"
! 						  " CASE\n"
! 						  "  WHEN p.proisagg THEN '%s'\n"
! 						  "  WHEN p.proiswindow THEN '%s'\n"
! 						  "  WHEN p.prorettype = 'pg_catalog.trigger'::pg_catalog.regtype THEN '%s'\n"
! 						  "  ELSE '%s'\n"
! 						  " END as \"%s\"",
! 						  gettext_noop("Result data type"),
! 						  gettext_noop("Argument data types"),
! 		/* translator: "agg" is short for "aggregate" */
! 						  gettext_noop("agg"),
! 						  gettext_noop("window"),
! 						  gettext_noop("trigger"),
! 						  gettext_noop("normal"),
! 						  gettext_noop("Type"));
! 	else if (pset.sversion >= 80400)
  		appendPQExpBuffer(&buf,
  					"  pg_catalog.pg_get_function_result(p.oid) as \"%s\",\n"
  				 "  pg_catalog.pg_get_function_arguments(p.oid) as \"%s\",\n"
